%define name limesurvey
%define majorversion 2.06lts
%define builddate 160329
%define release 2
%define httpuser apache
%define _binaries_in_noarch_packages_terminate_build 0

%if 0%{?fedora} >=17 || 0%{?rhel} >= 5
%global useselinux 1
%else
%global useselinux 0
%endif

Summary: Web based survey tool
Name: %{name}
Version: %{majorversion}.%{builddate}
Release: %{release}%{?dist}
License: GPLv2+
URL: http://limesurvey.org
Group: Applications/Internet
Source: %{majorversion}.zip
Source1: httpd.conf

Patch1: limesurvey-2.06-rewritebase.patch
Patch2: limesurvey-2.06-add_permissions_hook.patch

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)


Requires: php
Requires: php-mysql
Requires: php-gd
Requires: php-ldap
Requires: php-imap
Requires: php-mbstring
Requires: php-pecl(json)
Requires: httpd
Requires: php-pecl(APC)
%if %{useselinux}
Requires: %{_sbindir}/semanage
%endif

%description
To cut a very long story short: LimeSurvey has a lot of features
and contains everything you need for doing nearly every survey with grace

%prep
%setup -q -n LimeSurvey-%{majorversion}

%patch1 -p1
%patch2 -p1

%build
# empty build

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__mkdir} -p $RPM_BUILD_ROOT/%{_datadir}/%{name}

find ./ -type f -name .git\* -exec rm -f "{}" \;
%{__cp} -pr ./* $RPM_BUILD_ROOT/%{_datadir}/%{name}/
%{__cp} -p .htaccess $RPM_BUILD_ROOT/%{_datadir}/%{name}/
cat <<'_EOF' > $RPM_BUILD_ROOT/%{_datadir}/%{name}/robots.txt
User-agent: *
Disallow: /
_EOF
%{__mkdir_p} $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/sessions
%{__mv} $RPM_BUILD_ROOT/%{_datadir}/%{name}/{tmp,upload} $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/
ln -sf %{_localstatedir}/lib/%{name}/tmp $RPM_BUILD_ROOT/%{_datadir}/%{name}/tmp
ln -sf %{_localstatedir}/lib/%{name}/upload $RPM_BUILD_ROOT/%{_datadir}/%{name}/upload
find $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/ -type f -exec chmod 644 "{}" \;
find $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/ -type d -exec chmod 770 "{}" \;

# Doc will go in %doc dir
%{__cp} -pr $RPM_BUILD_ROOT/%{_datadir}/%{name}/docs ./docs
%{__cp} -pr $RPM_BUILD_ROOT/%{_datadir}/%{name}/installer/sql ./sql
%{__rm} -f $RPM_BUILD_ROOT/%{_datadir}/%{name}/README

%{__mkdir_p} $RPM_BUILD_ROOT/%{_sysconfdir}/
ln -sf %{_datadir}/%{name}/application/config $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}

# Install apache conf
%{__mkdir} -p $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/
%{__install} -m 0640 %{SOURCE1} $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf.d/%{name}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if %{useselinux}
(
# New File context
# keep httpd_sys_script_rw_t (httpd_var_lib_t prevent dir creation)
semanage fcontext -a -s system_u -t httpd_sys_script_rw_t -r s0 "%{_localstatedir}/lib/%{name}(/.*)?"
# files created by app
restorecon -R %{_localstatedir}/lib/%{name}
) &>/dev/null || :
%endif

%postun
%if %{useselinux}
if [ "$1" -eq "0" ]; then
    # Remove the File Context
    (
    semanage fcontext -d "%{_localstatedir}/lib/%{name}(/.*)?"
    ) &>/dev/null || :
fi
%endif


%files
%defattr(-,root,root)
%doc README
%doc docs sql
%{_datadir}/%{name}
%config(noreplace) %{_datadir}/%{name}/.htaccess
%dir %attr(770,root,%{httpuser}) %{_datadir}/%{name}/application/config/
%attr(660,root,%{httpuser}) %{_datadir}/%{name}/application/config/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}.conf
%{_sysconfdir}/%{name}
%defattr(-,%{httpuser},%{httpuser})
%{_localstatedir}/lib/%{name}

%changelog
* Mon Nov 21 2016 Daniel Berteaud <daniel@firewall-services.com> - 2.06.160329-2
- Disallow indexation with a robots.txt

* Wed Mar 30 2016 Daniel Berteaud <daniel@firewall-services.com> - 2.06.160329-1
- Update to 2.06lts build 160329

* Fri Jan 16 2015 Daniel B. <daniel@firewall-services.com> - 2.05.141229-2
- Add hook_get_auth_webserver_permissions

* Wed Jan 14 2015 Daniel B. <daniel@firewall-services.com> - 2.05.141229-1
- Update to 2.05 build 141229

* Mon Oct 28 2014 Daniel B. <daniel@firewall-services.com> - 2.05.141020-1
- Update to 2.05 build 141020
- Fix build on EL7
- Adapt httpd conf for httpd 2.4

* Wed Aug 13 2014 Daniel B. <daniel@firewall-services.com> - 2.05.140811-1
- Update to 2.05 build 140811
- Add a rewritebase directive so redirection from /admin works

* Tue Jul 29 2014 Daniel B. <daniel@firewall-services.com> - 2.05.140717-1
- update to 2.05 build 140717

* Tue May 10 2014 Daniel B. <daniel@firewall-services.com> - 2.05.140520-1
- update to 2.05 build 140520

* Thu Dec 19 2013 Daniel B. <daniel@firewall-services.com> - 2.05.131219-1
- Update to build 2.05 build 131219

* Wed Dec 4 2013 Daniel B. <daniel@firewall-services.com> - 2.00.131202-2
- Fix dependency on php-pecl-apc

* Tue Dec 3 2013 Daniel B. <daniel@firewall-services.com> - 2.00.131202-1
- Update to build 131202
- Add Requires php-pecl-apc

* Mon Nov 25 2013 Daniel B. <daniel@firewall-services.com> - 2.00.131122-1
- Update to build 131122

* Mon Nov 18 2013 Daniel B. <daniel@firewall-services.com> - 2.00-2
- Fix permissions on config dir

* Tue Oct 8 2013 Daniel B. <daniel@firewall-services.com> - 2.00-1
- Initial package

